-- Determine if we rewrite the body of this type of content
if ngx.header["Content-Type"] then
    local content_type = ngx.header["Content-Type"]
    if content_type:find("text/html") or
       content_type:find("text/css") or
       content_type:find("text/xml") or
       content_type:find("application/javascript") or
       content_type:find("application/rss+xml") or
       content_type:find("application/atom+xml") or
       content_type:find("application/vnd.mpegurl") or
       content_type:find("application/x-mpegurl") then
        ngx.ctx.rewriting = true
        ngx.header["Content-Length"] = nil
    end
end

-- Rewrite any redirects from the origin to point at a mirror
if ngx.header["Location"] then
    if ngx.ctx.jasima_pool_map and not ngx.ctx.jasima_config.rewrite_disable then
        local location = ngx.header["Location"]
        for from, to in pairs(ngx.ctx.jasima_pool_map) do
            if ngx.ctx.jasima_config.rewrite_case_insensitive then
                local pattern = ngx.re.escape(from)
                location = ngx.re.gsub(location, pattern, to, "ijo")
            else
                local pattern = from:gsub("([%^%$%(%)%%%.%[%]%*%+%-%?])", "%%%1") -- escape Lua patterns
                location = location:gsub(pattern, to)
            end
        end
        ngx.header["Location"] = location
    end
end